Subject: [tsvwg] draft-ietf-tcpm-accurate-ecn-09: AccECN option: why not EE1B first?

From: Neal Cardwell <[email-masked]>
Date: Mon, 11 Nov 2019 12:25:02 -0500

A particular question in regards to the AccECN option:

  https://tools.ietf.org/html/draft-ietf-tcpm-accurate-ecn-09#section-3.2.6

The AccECN option spec lists the EE0B field first, with the EE1B field
at the end.

Given that L4S plans on using ECT(1) for data packets, and unchanging
counter values can be omitted from the end of the AccECN option, why
not list EE1B first, and EE0B last? With EE1B first and EE0B last it
seems that in the common case for an L4S connection the (unchanged)
EE0B could be omitted, allowing 4 extra bytes of payload per packet.
AFAICT this extra 4 bytes would increase goodput for applications
using IPv4 or IPv6 with an MTU of 1500 by about 0.3%, by my
back-of-the-envelope calculations.

best,
neal